org.apache.commons.math3.linear

## Interface RealVectorPreservingVisitor

    public interface RealVectorPreservingVisitor

This interface defines a visitor for the entries of a vector. Visitors implementing this interface do not alter the entries of the vector being visited.

Since:
  3.1
Version:
  $Id: RealVectorPreservingVisitor.java 1416643 2012-12-03 19:37:14Z tn $

### Method Summary

Methods
`double` `end()` End visiting a vector.
`void` `start(int dimension, int start, int end)` Start visiting a vector.
`void` `visit(int index, double value)` Visit one entry of the vector.

### Method Detail

#### start

    void start(int dimension,
             int start,
             int end)

Start visiting a vector. This method is called once, before any entry of the vector is visited.

Parameters:
  `dimension` - the size of the vector
  `start` - the index of the first entry to be visited
  `end` - the index of the last entry to be visited (inclusive)

#### visit

    void visit(int index,
             double value)

Visit one entry of the vector.

Parameters:
  `index` - the index of the entry being visited
  `value` - the value of the entry being visited

#### end

    double end()

End visiting a vector. This method is called once, after all entries of the vector have been visited.

Returns:
  the value returned by `RealVector.walkInDefaultOrder(RealVectorPreservingVisitor)`, `RealVector.walkInDefaultOrder(RealVectorPreservingVisitor, int, int)`, `RealVector.walkInOptimizedOrder(RealVectorPreservingVisitor)` or `RealVector.walkInOptimizedOrder(RealVectorPreservingVisitor, int, int)`